代码随想录算法训练营第9天 | 28.找出字符串中第一个匹配项的下标、459.重复的子字符串

题目链接:28. 找出字符串中第一个匹配项的下标 - 力扣(LeetCode)

class Solution {
    public int strStr(String haystack, String needle) {
        if(haystack == null || haystack.length() == 0 || needle == null || needle.length() == 0){
            return -1;
        }
        int[] next = nextArr(needle);
        int j = 0;
        for(int i = 0; i < haystack.length(); i ++){
            while(j > 0 && haystack.charAt(i) != needle.charAt(j)){
                j = next[j - 1];
            }
            if(haystack.charAt(i) == needle.charAt(j)){
                j ++;
            }
            if(j == needle.length()){
                return i - needle.length() + 1;
            }
        }
        return -1;
    }
    public int[] nextArr(String needle){
        if(needle.length() == 1){
            int[] nextArr = new int[]{0};
            return nextArr;
        }else{
            int[] next = new int[needle.length()];
            next[0] = 0;
            int j = 0;
            for(int i = 1; i < needle.length(); i ++){
                while(j > 0 && needle.charAt(i) != needle.charAt(j)){
                    j = next[j - 1];
                }
                if(needle.charAt(i) == needle.charAt(j)){
                    j ++;
                }
                next[i] = j;
            }
            return next;
        }
        
    }
}

重点在于求next数组

题目链接:459. 重复的子字符串 - 力扣(LeetCode)

class Solution {
    public boolean repeatedSubstringPattern(String s) {
        if(s.length() == 1){
            return false;
        }
        int[] next = new int[s.length()];
        int j = 0;
        for(int i = 1; i < s.length(); i ++){
            while(j > 0 && s.charAt(i) != s.charAt(j)){
                j = next[j - 1];
            }
            if(s.charAt(i) == s.charAt(j)){
                j ++;
            }
            next[i] = j;
        }
        if(next[s.length() - 1] == 0){
            return false;
        }
        int n = s.length() % (s.length() - next[s.length() - 1]);
        if(n == 0){
            return true;
        }
        return false;
    }
}

这里是求next数组的解法,另一种解法是将两个字符串拼接,掐头去尾,再在里面找是否有原始字符串

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 1
    评论
第二十二天的算法训练主要涵盖了Leetcode题目的三道题目,分别是Leetcode 28 "Find the Index of the First Occurrence in a String",Leetcode 977 "有序数组的平方",和Leetcode 209 "长度最小的数组"。 首先是Leetcode 28题,题目要求在给定的字符串到第一个现的字符的索引。思路是使用双指针来遍历字符串,一个指向字符串的开头,另一个指向字符串的结尾。通过比较两个指针所指向的字符是否相等来判断是否到了第一个现的字符。具体实现的代码如下: ```python def findIndex(self, s: str) -> int: left = 0 right = len(s) - 1 while left <= right: if s[left == s[right]: return left left += 1 right -= 1 return -1 ``` 接下来是Leetcode 977题,题目要求对给定的有序数组的元素进行平方,并按照非递减的顺序返回结果。这里由于数组已经是有序的,所以可以使用双指针的方法来解决问题。一个指针指向数组的开头,另一个指针指向数组的末尾。通过比较两个指针所指向的元素的绝对值的大小来确定哪个元素的平方应该放在结果数组的末尾。具体实现的代码如下: ```python def sortedSquares(self, nums: List[int]) -> List[int]: left = 0 right = len(nums) - 1 ans = [] while left <= right: if abs(nums[left]) >= abs(nums[right]): ans.append(nums[left ** 2) left += 1 else: ans.append(nums[right ** 2) right -= 1 return ans[::-1] ``` 最后是Leetcode 209题,题目要求在给定的数组到长度最小的数组,

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论 1
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值